﻿Imports System.Windows.Forms
Imports C1.Win.C1FlexGrid

Public Class MDIParent1
    Private childFormNumber As Integer = 1
    Private childForm As Form
    Private childFlowLayoutPanel As FlowLayoutPanel
    Private c1FlexGrid2 As C1.Win.C1FlexGrid.C1FlexGrid
    Private m_ChildFormNumber As Integer

    Private Sub ShowNewForm(ByVal sender As Object, ByVal e As EventArgs) Handles NewToolStripMenuItem.Click
        childForm = New Form()
        childForm.MdiParent = Me
        childForm.Text = "Child Form: " & childFormNumber
        childForm.Name = "ChildForm" & m_ChildFormNumber - 1
        AddHandler childForm.Load, AddressOf childForm_Load
        childForm.Show()

    End Sub
    Private Sub CloseAllToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        ' Close all child forms of the parent.
        For Each ChildForm As Form In Me.MdiChildren
            ChildForm.Close()
        Next
    End Sub
    Public Sub childForm_Load(ByVal sender As Object, ByVal e As EventArgs)
        childFlowLayoutPanel = New FlowLayoutPanel()
        c1FlexGrid2 = New C1FlexGrid()
        c1FlexGrid2.Name = TryCast(sender, Form).Name.ToString() & "_C1FlexGrid"
        c1FlexGrid2.Location = New System.Drawing.Point(0, 0)

        c1FlexGrid2.Rows.DefaultSize = 19
        c1FlexGrid2.Size = New System.Drawing.Size(256, 218)

        childForm.Controls.Add(childFlowLayoutPanel)
        childFlowLayoutPanel.Controls.Add(c1FlexGrid2)


        childFlowLayoutPanel.AllowDrop = True
        childFlowLayoutPanel.Dock = DockStyle.Fill

        AddHandler c1FlexGrid2.MouseCaptureChanged, AddressOf c1FlexGrid2_MouseCaptureChanged
        AddHandler childFlowLayoutPanel.DragDrop, AddressOf childFlowLayoutPanel_DragDrop
        AddHandler childFlowLayoutPanel.DragEnter, AddressOf childFlowLayoutPanel_DragEnter

    End Sub
    Public Sub childFlowLayoutPanel_DragDrop(ByVal sender As Object, ByVal e As DragEventArgs)
        Dim data As C1FlexGrid = DirectCast(e.Data.GetData(GetType(C1FlexGrid)), C1FlexGrid)
        Dim _destination As FlowLayoutPanel = DirectCast(sender, FlowLayoutPanel)
        Dim _source As FlowLayoutPanel = DirectCast(DirectCast(data, C1FlexGrid).FindForm().Controls("childFlowLayoutPanel"), FlowLayoutPanel)
        If Not _source Is _destination Then
            ' Add control to panel
            _destination.Controls.Add(data)
        End If
    End Sub
    Public Sub childFlowLayoutPanel_DragEnter(ByVal sender As Object, ByVal e As DragEventArgs)
        e.Effect = DragDropEffects.Move
    End Sub
    Public Sub c1FlexGrid2_MouseCaptureChanged(ByVal sender As Object, ByVal e As EventArgs)
        childFlowLayoutPanel.DoDragDrop(TryCast(sender, C1FlexGrid), DragDropEffects.Move)
    End Sub
    Private Sub MDIParent1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
End Class
